<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: plugins/time/time.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: plugins/time/time.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>const plugin = require('../plugin.js')
var schema = require('./schema.json')

var timer = []

class Time extends plugin.Plugin {
  constructor() {
    super(schema)
    this.name = "time"
  }
  
  setup(config) {
    super.setup(config)
    return schema
  }
  
  cue(data, session) {
    for(let item in data) {
      switch(item) {
        case "time":
          if(data.time.hasOwnProperty("timeout")) {
            data.time["index"] = timer.length
            data.time.session = session.name
            let timeout = new Timeout(data.time, session.callback, session.date)
            timer.push(timeout)
            return timeout.cancel.bind(timeout)
          }
          if(data.time.hasOwnProperty("datetime")) {
            let datetime = new Datetime(data.time, session.callback, session.date)
            return datetime.cancel.bind(datetime)
          }
          break
      }
    }
  }
  
  command(input) {
    switch(input[0]) {
      case "list":
        for(let t of timer) {
          log.info(this.name + " " + t.index, t.secondsLeft() + " seconds until: " + t.session + "." + t.next)
        }
        break
      default:
        super.command(input)
        break
    }
    
  }
  
  /*
  * var dt = new Date()
  * setMinutes &amp; getMinutes &amp; getMilliseconds &amp; getUTCMilliseconds
  */
}

class Timer {
	constructor(props) {
		Object.assign(this, props)
	}

	done() {
		if(this.hasOwnProperty("next"))
		{
			log.info(this.name, "Done. Next: " + this.next)
			this.callback(this.next)
		} else {
			log.error(this.name, "has no next to dispatch")
		}
	}
  
  /**
  * from https://stackoverflow.com/questions/9640266/convert-hhmmss-string-to-seconds-only-in-javascript/9640417#9640417
  */
  hmsToSeconds(str) {
    var p = str.split(':'),
        s = 0, m = 1;

    while (p.length > 0) {
        s += m * parseInt(p.pop(), 10);
        m *= 60;
    }

    return s;
}
}

class Timeout extends Timer {
	constructor(properties, callback, start_date) {
		super(properties)
    this.name = "timeout"
		this.callback = callback
    this.start_date = start_date
    // log.debug(this.name, "cue happened at" + start_date.toISOString())
    
    this.timeout = this.hmsToSeconds(this.timeout)
    
    if(this.secondsLeft() &lt; this.timeout) {
      log.debug(this.name, "restart " + this.timeout + " seconds timeout with " + this.secondsLeft() + " seconds left to go")
    } else {
      log.debug(this.name, "start " + this.timeout + " seconds timeout")
    }

		this.function = setTimeout(this.done.bind(this), this.timeout*1000-this.timeElapsed())
	}
  
  secondsLeft() {
    let time_since = new Date(Date.now() - this.start_date)
    return Math.round((this.timeout*1000-time_since)/1000)
  }
  
  timeElapsed() {
    return new Date(Date.now() - this.start_date)
  }
  
	cancel() {
    if(this.secondsLeft()) {
      log.debug(this.name, "cancel " + this.timeout + " seconds timeout. " + this.secondsLeft() + " seconds before it was done.")
    }
    timer.splice(this.index, 1)
    for(let i = 0; i &lt; timer.length; i++) {
      timer[i].index = i
    }
		clearTimeout(this.function)
	}
}

module.exports.Plaitool = Time
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
